local HardFinger = _G.HardFinger
local P = HardFinger.HardFinger_Config

HardFinger.ENCOUNTERS_ID = {
["EMERALD"] = {1873, 1877, 1864}, -- EN
["TOV"] = {1958, 1962, 2008}, -- TOV
["NH"] = {1849, 1865, 1867, 1871, 1862, 1842, 1886, 1872, 1863, 1866}, -- NH
}

COMBATLOG_OBJECT_REACTION_FRIENDLY	= COMBATLOG_OBJECT_REACTION_FRIENDLY or 0x00000010

COMBATLOG_OBJECT_TYPE_PET		= COMBATLOG_OBJECT_TYPE_PET or 0x00001000
COMBATLOG_OBJECT_TYPE_GUARDIAN		= COMBATLOG_OBJECT_TYPE_GUARDIAN or 0x00002000
COMBATLOG_OBJECT_TYPE_NPC 		= COMBATLOG_OBJECT_TYPE_NPC or 0x0000800
PET_FILTER_BITMASK			= COMBATLOG_OBJECT_TYPE_PET + COMBATLOG_OBJECT_TYPE_GUARDIAN + COMBATLOG_OBJECT_TYPE_NPC

COMBATLOG_OBJECT_AFFILIATION_RAID	=	COMBATLOG_OBJECT_AFFILIATION_RAID or 0x00000004
COMBATLOG_OBJECT_AFFILIATION_PARTY	=	COMBATLOG_OBJECT_AFFILIATION_PARTY or 0x00000002
COMBATLOG_OBJECT_AFFILIATION_MINE	=	COMBATLOG_OBJECT_AFFILIATION_MINE or 0x00000001
MINE_PARTY_RAID_BITMASK = COMBATLOG_OBJECT_AFFILIATION_RAID + COMBATLOG_OBJECT_AFFILIATION_PARTY + COMBATLOG_OBJECT_AFFILIATION_MINE

HardFinger.FailTable = {}
FailTable = HardFinger.FailTable
FailTable.Data = {}
HardFinger.WhoPulledTable = {}
WhoPulledTable = HardFinger.WhoPulledTable
HardFinger.PetOwnersTable = {}
PetOwnersTable = HardFinger.PetOwnersTable
HardFinger.MobDeathsTable = {}
MobDeathsTable = HardFinger.MobDeathsTable
HardFinger.TargetsAvailableGeneratedTable = {}
TargetsAvailableGeneratedTable = HardFinger.TargetsAvailableGeneratedTable
HardFinger.TimersTable = {}
TimersTable = HardFinger.TimersTable
HardFinger.GenericTable = {}
GenericTable = HardFinger.GenericTable

function HardFinger.TableHardCopy(orig)
	-- Credits to http://lua-users.org/wiki/CopyTable
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[HardFinger.TableHardCopy(orig_key)] = HardFinger.TableHardCopy(orig_value)
        end
        setmetatable(copy, HardFinger.TableHardCopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

-- Funo Targets Disponiveis
function HardFinger.GenerateTargetsTableSoakID(event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, spellID)
    if spellIDToTrack == spellID and string.find(event,message) then
		if delay == nil then
			if UnitIsDeadOrGhost("player") == false and (string.find(string.upper(roles),UnitGroupRolesAssigned("player")) or roles == "ALL") then
				TargetsAvailableGeneratedTable[event..spellIDToTrack] = {[UnitGUID("player")] = UnitName("player")}
			end

			local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
			HardFinger.InstanceSize = instanceSize
			for i=1, instanceSize do
				if UnitIsDeadOrGhost(HardFinger.ValidUnitFrameGUID..i) == false then
					if string.find(string.upper(roles),UnitGroupRolesAssigned(HardFinger.ValidUnitFrameGUID..i)) then
						local spellNameToCheck = GetSpellInfo(spellIDBuffDebuff) -- Get SpellName for UnitBuff/Debuff function
						if buffOrDebuffFunc == nil or buffOrDebuffFunc(UnitName(HardFinger.ValidUnitFrameGUID..i), spellNameToCheck) ~= nil then
							TargetsAvailableGeneratedTable[event..spellIDToTrack][UnitGUID(HardFinger.ValidUnitFrameGUID..i)] = Ambiguate(UnitName(HardFinger.ValidUnitFrameGUID..i), "short")
						end
					end
				end
			end
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..event..spellIDToTrack.."] created")
		else
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.GenerateTargetsTableSoakID, spellIDToTrack..tostring(buffOrDebuffFunc), event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, nil, message, spellID)
		end
    end
end

-- Funo Targets Disponiveis
function HardFinger.AddToTargetsTableSoakID(event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, destName, spellID)
    if HardFinger.IsIn(spellID, spellIDToTrack) and string.find(event,message) then
		if delay == nil then
			if UnitIsDeadOrGhost(destName) == false and (string.find(string.upper(roles),UnitGroupRolesAssigned(destName)) or roles == "ALL") then
			
				local hasBuffDebuff = false -- ID spells can be a list
				if buffOrDebuffFunc ~= nil then
					for k,v in pairs(spellIDBuffDebuff or {}) do
						local spellNameToCheck = GetSpellInfo(v)
						if buffOrDebuffFunc(UnitName(HardFinger.ValidUnitFrameGUID..i), spellNameToCheck) ~= nil then
							hasBuffDebuff = true
							break
						end
					end
				end
				
				if buffOrDebuffFunc == nil or hasBuffDebuff == true then
					TargetsAvailableGeneratedTable[event..spellIDToTrack][UnitGUID(destName)] = HardFinger.SName(destName)
				end
			end
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..event..spellIDToTrack.."] added")
		else
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.AddToTargetsTableSoakID, spellIDToTrack..tostring(buffOrDebuffFunc), event, spellIDToTrack, buffOrDebuffFunc, spellIDBuffDebuff, roles, delay, message, destName, spellID)
		end
    end
end


function HardFinger.DelayedTimer(action, timer, func, timerName, ...)
	if action == "Update" then
		for k, v in pairs(TimersTable) do
			if v.endTimer <= GetTime() then
				TimersTable[k] = nil
				v.functionToCall(unpack(v.arguments))
			end
		end
	elseif action == "AddANewTimer" then
		HardFinger.DPrint(timerName.." "..tostring(func).." added") 
		if TimersTable[timerName] == nil then
			TimersTable[timerName] = {startTimer = GetTime(), endTimer = GetTime()+timer, functionToCall = func, arguments = {...}}
		end
	end
end

-- Funo Display tables
function HardFinger.DisplayTable(tableToDisplay, spellIDTrigger, messageTrigger, spellIDIcon, text, delay, shouldShow, shouldTrack, message, spellID)
    if TargetsAvailableGeneratedTable[tableToDisplay] ~= nil then
		if delay == nil then
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..tableToDisplay.."]")

			local stringOfNames = ""
			for _,name in pairs(TargetsAvailableGeneratedTable[tableToDisplay]) do
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellIDIcon, text, name)
				end
				stringOfNames = stringOfNames..name.. ", "
			end
			if stringOfNames ~= "" then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.StringOfNames = stringOfNames:sub(1,#stringOfNames-2) -- Remove last ", "
					HardFinger.SendChat(GetSpellLink(spellIDIcon)..text, P.ReportChannel)
					HardFinger.SendChat(stringOfNames, P.ReportChannel)
				end
				wipe(TargetsAvailableGeneratedTable[tableToDisplay])
			end
		elseif spellIDTrigger == spellID and string.find(messageTrigger,message) then
			HardFinger.DPrint("TargetsAvailableGeneratedTable["..tableToDisplay.."] called to be displayed")
			HardFinger.DPrint("timer started")
			HardFinger.DelayedTimer("AddANewTimer", delay, HardFinger.DisplayTable, spellIDIcon..tostring(tableToDisplay), tableToDisplay, spellIDTrigger, messageTrigger, spellIDIcon, text, nil, shouldTrack, message, spellName, spellID)
		end
    end
end

function HardFinger.BadSpellAuraSpreadID(spellIDToTrack, safeSource, shouldShow, shouldTrack, message, spellID, sourceName, destName)
    if spellIDToTrack == spellID then
        if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
            local sourceName = HardFinger.SName(sourceName) -- Strip away realm name
            local destName = HardFinger.SName(destName) -- Strip away realm name
            if sourceName ~= safeSource then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
                    HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." spreaded to "..destName..".", P.ReportChannel)
                end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
                    HardFinger.ModifyFailTable(spellID, "Bad Spread Count:", sourceName)
                end
            end
        end 
    end    
end

function HardFinger.CombatToggle(status)
	if status == "OUT_OF_COMBAT" and UnitIsDeadOrGhost("player") == false then
		wipe(WhoPulledTable)

		wipe(PetOwnersTable)
		HardFinger.WorldInfo()
	elseif status == "IN_COMBAT" then
		--
	end

end

-- Funcao announce aura applied
function HardFinger.AnnounceAuraID(spellIDToTrack, message, destName, spellID)
	if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
		if spellIDToTrack == spellID then
			destName = HardFinger.SName(destName) -- Strip away realm name
			HardFinger.SendChat(destName.." is affected by "..GetSpellLink(spellID)..".", P.ReportChannel)
		end
	end
end

-- Funao AURA_APPLIED, AURA_APPLIED_DOSE
function HardFinger.BadSpellAuraSpreadID(spellIDToTrack, safeSource, shouldShow, shouldTrack, message, spellID, sourceName, destName)
	if spellIDToTrack == spellID then
		if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
			sourceName = HardFinger.SName(sourceName) -- Strip away realm name
			destName = HardFinger.SName(destName) -- Strip away realm name
			if sourceName ~= safeSource then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." spreaded to "..destName..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Bad Spread Count:", sourceName)
				end
			end
		end
	end
end

function HardFinger.TimedMessage(timerName, timer, channel, text, numberOfTimes)
	GenericTable[timerName] = GenericTable[timerName] or false
	local timeDiff = math.floor(GetTime() - HardFinger.EncounterTimer)
	if GenericTable[timerName] == false then
		if timeDiff == timer and GenericTable[timerName] == false then
			if channel == "RAID_WARNING" then
				for i=1,(numberOfTimes or 1) do
					SendChatMessage(text, channel)
				end
				GenericTable[timerName] = true
			end
		end
	elseif timeDiff == (timer+1) or timeDiff == 1 then
		GenericTable[timerName] = false
	end
end

-- Has Interrupts
HardFinger.InterruptTable = {}
InterruptTable = HardFinger.InterruptTable
InterruptCDs = {[187707] = 15, -- Muzzle, Survival Hunter
 [1766] = 15, [57994] = 12, [31935] = 15, [183752] = 15, [147362] = 24, [96231] = 15,
    [15487] = 45, [6552] = 15, [32747] = 90}
function HardFinger.HasInterrupt(spellIDToTrack, shouldShow, shouldTrack, message, spellID, sourceName, destName)
    if spellName == "Arcane Torrent" and message == "SPELL_CAST_SUCCESS" then
        InterruptTable[sourceName] = InterruptTable[sourceName] or {}
        InterruptTable[sourceName]["Arcane Torrent"] = GetTime()+90.5
    else
        for k,_ in pairs(InterruptCDs) do
            if k == spellID and message == "SPELL_CAST_SUCCESS" then
                InterruptTable[sourceName] = InterruptTable[sourceName] or {}
                InterruptTable[sourceName][spellID] = GetTime()+InterruptCDs[spellID]+0.5
                break
                
            end
        end
    end
    if spellIDToTrack == spellID and message == "SPELL_CAST_SUCCESS" then        
        HardFinger.DPrint(GetSpellLink(spellIDToTrack).. " cast finished.")
        local textPlayerNames = ""
        if InterruptTable ~= nil then
            for k,t in pairs(InterruptTable) do
                for spell,v in pairs(t) do
                    if GetTime() - v > 600 then
                        InterruptTable.k = nil
                    elseif GetTime() > v and UnitIsDeadOrGhost(k) == false then
						if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
							HardFinger.ModifyFailTable(spellIDToTrack, "Missed Interrupts:", k)
						end
                        if spell == "Arcane Torrent" then
                            textPlayerNames = textPlayerNames..HardFinger.SName(k).."(Racial), "
                        else
                            textPlayerNames = textPlayerNames..HardFinger.SName(k)..", "                                    
                        end
                    end
                end
            end
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				if textPlayerNames ~= "" then
					textPlayerNames = textPlayerNames:sub(1,#textPlayerNames-2) -- Remove last ", "
					HardFinger.SendChat(textPlayerNames.." failed to interrupt "..GetSpellLink(spellID), P.ReportChannel)
				end
			end
        end
    end
end

function HardFinger.DamageFromSpellExpiration(spellIDToTrack, shouldTrack, shouldShow, message, spellID, sourceName, destName)
	if spellID == spellIDToTrack and message == "SPELL_AURA_REMOVED" then
		HardFinger.LastPersonToHaveSpell = false
	end
end

function HardFinger.WorldInfo()
	_,_,instanceType,_,_,_,_,_,instanceSize = GetInstanceInfo()
	if instanceType == 23 or instanceType == 8 then -- 5 man
		HardFinger.ProperTrigger = "DUNGEON"
	else
		HardFinger.ProperTrigger = "GENERIC"
	end
	if instanceType == 0 and not IsInGroup() then
		HardFinger.ProperChannel = "SAY"
	elseif instanceType == 17 then -- 17 = LFR
		HardFinger.ProperChannel = "INSTANCE_CHAT"
		HardFinger.ValidUnitFrameGUID = "raid"
	elseif instanceType >= 14 and instanceType <= 16 then -- 16 = Mythic Raid
		HardFinger.ProperChannel = "RAID"
		HardFinger.ValidUnitFrameGUID = "raid"
	else
		HardFinger.ProperChannel = "PARTY"
		HardFinger.ValidUnitFrameGUID = "party"
	end

	if instanceSize == 0 then
		HardFinger.InstanceSize = GetNumGroupMembers()-1
	end

	if HardFinger.ActiveEcounter ~= 0 then
		for k, v in pairs(HardFinger.ENCOUNTERS_ID) do
			if HardFinger.IsIn(HardFinger.ActiveEncounter, v) then
				HardFinger.ProperTrigger = k
				break
			end
		end
	end
	
	-- Make variables "global"
	HardFinger.InstanceType = instanceType
	HardFinger.ActiveEncounter = HardFinger.ActiveEncounter or 0
end

function HardFinger.IsIn(object, table)
    if type(table) ~= "table" then
        return object == table
    end
    local result = false
    for _,v in pairs(table) do
        if v == object then
            result = true
            break
        end
        
    end
    return result
end

--message, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, param12, param13, param14 = ...

function HardFinger.HelpfulSoakAuraID(spellToTrack, makezeros, text, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		-- local role = UnitGroupRolesAssigned(destName)
		
		-- Leaving roles filter for makezeros only
		--if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then

			local destName = HardFinger.SName(destName)
			if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID)..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					if makezeros == true then
						HardFinger.MakeZerosFailTable(spellID, text, roles)
					end
					HardFinger.ModifyFailTable(spellID, text, destName)
				end
			end
		--end
	end
end

function HardFinger.HelpfulSoakID(spellToTrack, makezeros, text, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)

		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
			local damageTaken = -1
			local destName = HardFinger.SName(destName)
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" and damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
				damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
				
			elseif message == "SPELL_DAMAGE" then
				local absorbed = absorbAmount or 0
				local overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
			end
	
			if damageTaken >= amountThreshold then -- If damage really happened
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID).." and got hit for "..HardFinger.FormatDamage(damageTaken)..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					if makezeros == true then
						HardFinger.MakeZerosFailTable(spellID, text, roles)
					end
					HardFinger.ModifyFailTable(spellID, text, destName)
				end
			end
		end
	end
end

function HardFinger.BadSpellHitID(spellToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)
		
		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then

			local damageTaken = -1
			local destName = HardFinger.SName(destName)
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" and damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
				damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
				
				
			elseif message == "SPELL_DAMAGE" then
				local absorbed = absorbAmount or 0
				local overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
			end
	
			if damageTaken >= amountThreshold then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					local text = destName.." failed miserably. "..GetSpellLink(spellID).." Hit:  "..HardFinger.FormatDamage(damageAmount).."."
					if overkill > 0 then
					text = text.." Overkill: "..HardFinger.FormatDamage(overkill).."."
					end
					HardFinger.SendChat(text, P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Total times hit: ", destName)
				end
			end
		end
	end
end

function HardFinger.SpellAuraRemoved(spellIDToTrack, text, shouldShow, shouldTrack, message, spellID, sourceName)
	if message == "SPELL_AURA_REMOVED" then
		if spellID == spellIDToTrack then
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				HardFinger.SendChat(sourceName.." failed miserably. "..GetSpellLink(spellID).." removed.", P.ReportChannel)
			end
			if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
				HardFinger.ModifyFailTable(spellID, text, destName)
			end
		end
	end
end

function HardFinger.BadSpellHitIDDeath(spellToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmount)
	if spellToTrack == spellID and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE") and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		local overkill = overKillAmount or 0
		if overkill > 0 then
			destName = HardFinger.SName(destName) -- Strip away realm name
			local role = UnitGroupRolesAssigned(destName)
			if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
				local absorbed = absorbAmount or 0
				local damageTaken = damageAmount + absorbed
	
				if damageTaken >= amountThreshold then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." Hit: "..HardFinger.FormatDamage(damageTaken)..". Overkill: "..HardFinger.FormatDamage(overKillAmount)..".", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, "Deaths: ", destName)
					end
				end
			end
		end
	end
end

function HardFinger.toggletf(variable)
	if variable ~= true then		return true	else		return false	end
end

function HardFinger.toggle01(variable)
	if variable ~= 1 then		return 1	else		return 0	end
end


function HardFinger.StatusText(variable)
	if variable ~= 1 and variable ~= true then
		return "|cffff0000Off"
	else
		return "|c0000FF00On"
	end
end

HardFinger.LastHitTimerSpell = {}
LastHitTimerSpell = HardFinger.LastHitTimerSpell

function HardFinger.UniqueSpellHitInInterval(spellIDToTrack, interval, message, spellID, destName, absorbAmountMissed)
	local damageTaken = -1
	local destName = HardFinger.SName(destName)

	-- Was it fully absorbed?
	if message == "SPELL_MISSED" and damageAmount == "ABSORB" then -- damageAmount is param13 which has the type of the MISS
		damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED
	
	elseif message == "SPELL_DAMAGE" then
		local absorbed = absorbAmount or 0
		local overkill = overKillAmount or 0
		damageTaken = damageAmount + absorbed
	end
	
	if damageTaken > 0 then -- If damage really happened
		if GetTime() - (LastHitTimerSpell[spellID] or 0) > interval then
			if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
				HardFinger.SendChat(destName.." saved the world by soaking. "..GetSpellLink(spellID)..".", P.ReportChannel)
			end
			if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
				HardFinger.ModifyFailTable(spellID, "Soaks: ", destName)
			end
		end
		LastHitTimerSpell[spellID] = GetTime()
	end
end
-- Funcao remove from table
function HardFinger.RemoveFromTableIDbyEvent(tableToModify, event, spellIDToTrack, message, tableKey, spellID)
	if TargetsAvailableGeneratedTable[tableToModify] == nil or TargetsAvailableGeneratedTable[tableToModify] == {} then
		return
	end
	if HardFinger.IsIn(spellID, spellIDToTrack) and string.find(event,message) then
		if TargetsAvailableGeneratedTable[tableToModify][tableKey] == nil then
			HardFinger.DPrint("key = "..tableKey.." does not exists.")
			return
		end
		TargetsAvailableGeneratedTable[tableToModify][tableKey] = nil
	end
end

function HardFinger.FindOwnerPetFromGUID(petName,petGUID) -- Credits to Recount

	local ownerName
	local ownerGUID
	local ownerRealm
	if PetOwnersTable[petGUID] ~= nil then
		return PetOwnersTable[petGUID][1], PetOwnersTable[petGUID][2]
    end

	if petGUID==UnitGUID("pet") then
		ownerName = UnitName("player")

		ownerGUID = UnitGUID("player")
		PetOwnersTable[petGUID] = {ownerName, ownerGUID}
		return ownerName, ownerGUID

	end
	
	local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
	HardFinger.InstanceSize = instanceSize
		
	if HardFinger.InstanceSize > 0 then
		for i = 1, HardFinger.InstanceSize, 1 do -- GetNumRaidMembers()
			if petGUID == UnitGUID("raidpet"..i) then
				ownerName, ownerRealm = UnitName("raid"..i)
				if ownerRealm then
					ownerName = ownerName .. "-" .. ownerRealm
				end
				ownerGUID = UnitGUID("raid"..i)
				PetOwnersTable[petGUID] = {ownerName, ownerGUID}
				return ownerName, ownerGUID
			end
		end
	end
	HardFinger.DPrint(petName.." owner not found")
	return petName, petGUID
end

function HardFinger.DamageToTarget(targetNameToTrack, desc, message, sourceGUID, sourceName, sourceFlags, destName, spellID, damageAmount, overKillAmount, absorbAmount)
	if destName == targetNameToTrack and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SWING_DAMAGE") then
		local absorbed, damaged, damageDone
		if message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then
			absorbed = absorbAmount or 0
			damaged = damageAmount or 0
		else
			absorbed = absorbAmount or 0
			damaged = spellID or 0 -- For melee swings, damageAmount is the same nth parameter as spellID
			spellName = "Melee Swing"
		end
		damageDone = damaged + absorbed

		local sourceDamage = sourceName
		if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
			sourceDamage,_ = HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID)
		end
	
		if desc ~= nil and sourceDamage ~= nil and damageDone ~= nil then -- Not necessary, but just to be safe
			HardFinger.ModifyFailTable(desc, "Damage Done ["..targetNameToTrack.."]: ", sourceDamage, damageDone)
		end
	end
end

-- Funao AURA_APPLIED, AURA_APPLIED_DOSE, param14 = amount

function HardFinger.BadSpellAuraID(spellIDToTrack, text, stackAmount, modulo, shouldShow, shouldTrack, message, destName, spellID, numberOfStacks)
	if spellIDToTrack == spellID then
		if message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
			destName = HardFinger.SName(destName) -- Strip away realm name
			if stackAmount == -1 then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID))
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, text, destName, 1) -- Increment by 1
				end
			elseif numberOfStacks ~= nil and numberOfStacks > stackAmount then
				if modulo == nil or modulo == -1 then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID).." "..numberOfStacks.." stacks.", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, text, destName, nil, numberOfStacks)
					end
				elseif stackAmount >= numberOfStacks and mod(numberOfStacks-stackAmount, modulo) == 0 then
					if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
						HardFinger.SendChat(destName.." has failed miserably. "..GetSpellLink(spellID).." "..numberOfStacks.." stacks.", P.ReportChannel)
					end
					if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
						HardFinger.ModifyFailTable(spellID, text, destName, nil, numberOfStacks)
					end
				end
			end
		end
	end
end


function HardFinger.DisplayFailTable(call)
	--HardFinger.DPrint("Entered function displayFailTable")
	if call == "HRESET" then
		wipe(FailTable.Data or {})
		wipe(FailTable.Header or {})
		HardFinger.DPrint("Failtable HReset")
		return
	end
	-- Check whether FailTable is empty, if so, return
	local next = next
	if next(FailTable.Data) == nil then
		HardFinger.DPrint("failTable is empty")
	else
		HardFinger.FailTableDelayTimer = HardFinger.FailTableDelayTimer or GetTime()
		if (GetTime() - HardFinger.FailTableDelayTimer) > 1 then
			HardFinger.DPrint("failTable being displayed") -- Debug only
			
			-- Print HardFinger report + Attempt# header
			
			local header = "HardFinger Report"
			
			local next = next
			if next(FailTable.Header) ~= nil then
				header = header.." for "..FailTable.Header.EncounterName.. " - " ..FailTable.Header.Attempt
			end
			HardFinger.SendChat(header, P.ReportChannel)
			
			
			for spell,spellTable in pairs(FailTable.Data) do
				local counter = ""
				if HardFinger.IsIn(spellTable.description, {"Total times hit: ", "Deaths: ", " Frozen", " Fear applications: ", " Souls absorbed: ", " Bombs Applications: ", " Cakes Eaten: ", " Players Frozen: "}) == true then
					counter, counter2 = HardFinger.SumVectorValues(spellTable.players)
				end
				local counter2text = ""
				if counter2 ~= nil then
					-- counter2text = "#Players: "..counter2
				end
				-- spell Icon
				spellIconTextOrLink = spellTable.spellIcon
				if type(spellTable.spellIcon) == "number" then
					spellIconTextOrLink = (GetSpellLink(spellTable.spellIcon))
				end
				HardFinger.SendChat(spellIconTextOrLink.." "..(spellTable.description)..counter..counter2text, P.ReportChannel)
				local textRows = {[1] = ""}
				local index = 1
				for _,unit in HardFinger.Spairs(spellTable.players, function(t,a,b) return t[b].counter < t[a].counter end) do
					if #textRows[index] > 220 then
						index = index + 1
					end
					textToAdd = HardFinger.SName(unit.name).."  "..HardFinger.FormatDamage(unit.counter).. ", "
					textRows[index] = (textRows[index] or "")..textToAdd
				end
				textRows[index] = textRows[index]:sub(1,#textRows[index]-2) -- Remove last ", " from the last textRow
				for i=1, #textRows do

					HardFinger.SendChat(textRows[i], P.ReportChannel)
				end
			end
			--wipe(FailTable)
			HardFinger.FailTableDelayTimer = nil
		end
	end
end

-- Funao bad SPELL_DAMAGE spread
function HardFinger.BadSpreadDamageID(spellToTrack, unitName, amountThreshold, roles, shouldShow, shouldTrack, message, sourceName, destName, spellID, damageTaken, overkill)
    if spellToTrack == spellID then
        if message == "SPELL_DAMAGE" or message == "SPELL_ABSORB" then
            absorbed = absorbed or 0
            damageTaken = damageTaken + absorbed
            sourceName = HardFinger.SName(sourceName) -- Strip away realm name
            destName = HardFinger.SName(destName) -- Strip away realm name
            if sourceName ~= destName then
                if sourceName ~= unitName then
                    local role = UnitGroupRolesAssigned(sourceName)
                    if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
                        if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
                            HardFinger.SendChat(sourceName.." hit "..destName.." "..GetSpellLink(spellID).." "..damageTaken, P.ReportChannel)                
                        end   
                        if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
                            HardFinger.ModifyFailTable(spellID, "Spread Fail [Friendly Fire]: ", sourceName, damageTaken)
                        end
                    end
                end
            end
        end
    end
end

function HardFinger.BadSpellDamageID(spellIDToTrack, amountThreshold, roles, shouldShow, shouldTrack, message, destName, destFlags, spellID, damageAmount, overKillAmount, absorbAmountMissed, absorbAmount)
	if spellIDToTrack == spellID and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then
		-- Role check
		local role = UnitGroupRolesAssigned(destName)
		if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
		
			local damageTaken = -1
			local destName = HardFinger.SName(destName)
			-- Was it fully absorbed?
			if message == "SPELL_MISSED" and damageAmount == "ABSORB" then
				damageTaken = absorbAmountMissed or 0 -- Absorb goes into param15 in SPELL_MISSED

				
			elseif message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then
				local absorbed = absorbAmount or 0
				local overkill = overKillAmount or 0
				damageTaken = damageAmount + absorbed
			end
			
			if damageTaken >= amountThreshold then
				if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
					HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." hit for "..HardFinger.FormatDamage(damageTaken)..".", P.ReportChannel)
				end
				if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
					HardFinger.ModifyFailTable(spellID, "Total damage taken: ", destName, damageTaken)
				end
			end
		end
	end
end

function HardFinger.Spairs(t, order)
	-- collect the keys
	local keys = {}
	for k in pairs(t) do
		keys[#keys+1] = k
	end
	-- if order function given, sort by it by passing the table and keys a, b,
	-- otherwise just sort the keys
	if order then
		table.sort(keys, function(a,b) return order(t, a, b) end)
	else
		table.sort(keys)
	end
	-- return the iterator function
	local i = 0
	return function()
		i = i + 1
		if keys[i] then
			return keys[i], t[keys[i]]
		end
	end
end

--Funcao Announce Dispel

function HardFinger.AnnounceDispel(spellToTrack, message, sourceName, destName, debuff)
	if message == "SPELL_DISPEL" then
		if param14 == spellToTrack then
			sourceName = HardFinger.SName(sourceName) -- Strip away realm name
			destName = HardFinger.SName(destName) -- Strip away realm name
			HardFinger.SendChat(sourceName.." has dispeled "..debuff.." from "..destName..".", P.ReportChannel)
		end

	end

end


function HardFinger.MobDeaths(Reset, SendReport, mobName, message, spellID, destName, param14)
	if Reset == true then
		MobDeathsTable[mobName] = 0
	elseif SendReport == true and MobDeathsTable[mobName] ~= nil then
		HardFinger.SendChat("Total "..mobName.." killed: "..MobDeathsTable[mobName]..".", P.ReportChannel)
		wipe(MobDeathsTable)
	elseif message == "SPELL_DAMAGE" then
		if destName == mobName and param14 > 0 and MobDeathsTable[mobName] ~= nil then
			MobDeathsTable[mobName] = MobDeathsTable[mobName] + 1
		end
	end
end

function HardFinger.TauntRezLust(message, sourceName, sourceRaidFlags, destName, destFlags, destRaidFlags, spellID)
	if bit.band(destFlags, MINE_PARTY_RAID_BITMASK) ~= 0 then
		-- 6795 = Growl, 62124 = Hand of Reckoning, 355 = Taunt, 116189 = Provoke, 185245 = Torment, 56222 = Dark Command
		if P.Taunt == true and HardFinger.IsIn(spellID, {6795, 62124, 355, 116189, 185245, 56222}) then
			-- 6795 = Growl, 62124 = Hand of Reckoning, 355 = Taunt, 116189 = Provoke, 185245 = Torment, 56222 = Dark Command
			if message == "SPELL_AURA_APPLIED" then
				rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
				destName = HardFinger.SName(destName)
				sourceName = HardFinger.SName(sourceName)
				HardFinger.SendChat(sourceName.." "..GetSpellLink(spellID).."'d "..rIcon..destName..rIcon..".", P.ReportChannel)
			end
		elseif message == "SPELL_CAST_SUCCESS" then
			--61999 = Raise Ally, 20484 = Rebirth, 20707 = Soulstone, 21169 = Reincarnation
			if P.BattleRez == true and HardFinger.IsIn(spellID, {61999, 20484, 20707, 21169}) then
				if spellID == 21169 then
					rIcon = HardFinger.GetRaidMarkByFlags(sourceRaidFlags)
					HardFinger.SendChat(rIcon..sourceName..rIcon.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
				else
					rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID).." on "..rIcon..destName..rIcon..".", P.ReportChannel)
				end
			--90355 = Hysteria (hunter pet), 2825 = Blood Lust, 80353 = Time Warp, 178207 = Drums of Fury, 230935 = Drums of the Mountain
			elseif P.BloodLust and HardFinger.IsIn(spellID, {90355, 2825, 80353, 178207, 230935}) then
				HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
			end
		end
	end
end

function HardFinger.WhoRezzed(message, sourceName, destName, destFlags, destRaidFlags, spellID)
	if message == "SPELL_CAST_SUCCESS" then
		--61999 = Raise Ally, 20484 = Rebirth, 20707 = Soulstone
        	if HardFinger.IsIn(spellID, {61999, 20484, 20707}) then
				if bit.band(destFlags, MINE_PARTY_RAID_BITMASK) ~= 0 then
					rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID).." on "..rIcon..destName..rIcon..".", P.ReportChannel)
				end
			end
	end
end

function HardFinger.WhoLusted(message, sourceName, spellID)
	if message == "SPELL_CAST_SUCCESS" then
		--2825 = Blood Lust, 80353 = Time Warp, 178207 = Drums of Fury
        	if HardFinger.IsIn(spellID, {2825, 80353, 178207}) then
					HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID)..".", P.ReportChannel)
		end
	end
end

function HardFinger.RetrieveWhoPulled(tableetry, destRaidFlags)
	if WhoPulledTable[tableetry] ~= nil then
		local WPName = WhoPulledTable[tableetry].WhoPulled
		local WPSpellLink = GetSpellLink(WhoPulledTable[tableetry].SpellPulled)
		local MobIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
		local WPTimeDiff = format(" %.1fs", GetTime() - WhoPulledTable[tableetry].TimePulled)
		local text = WPName.." pulled"..MobIcon..UnitName("target")..MobIcon.."with "..WPSpellLink..WPTimeDiff.." ago."
		HardFinger.SendChat(text, P.WhoPulledChannel)
	else
		print("HardFinger - Invalid target to retrieve information about WhoPulled.")
	end
end

function HardFinger.WhoPulled(name, beforeTimer, message, sourceGUID, sourceName, destGUID, destName, destFlags, spellID, specialUniqueKey)
	if WhoPulledTable[specialUniqueKey or destGUID] == nil then
		if (string.find(name, destName or "") or name == "ALL") and spellID ~= 137619 and spellID ~= 203528  then
			if message == "SPELL_DAMAGE" or message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
				if string.find(sourceGUID, "Player") or string.find(sourceGUID, "Pet") then
					if bit.band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) == 0 then
						if sourceName ~= destName then
							-- Get the name of who pulled this mob
							local wpname = HardFinger.SName(sourceName)
							local temptext = wpname

							-- If its a pet, get owner instead
							if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
								local petname = wpname
								-- get owner name
								wpname = HardFinger.SName(HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID))
								temptext = petname.." ("..wpname.."'s pet)"
							end
	                            
							local text = temptext.." aggroed "..destName.." with "..GetSpellLink(spellID)
							if beforeTimer == true and GetTime() < (HardFinger.DBMPullTimer or 0)-0.1 then
								local diff = HardFinger.DBMPullTimer - GetTime()
								diff = format("%.1fs", diff)
								text = text.." ("..diff.." before DBM Pull)"
							end
							if name == "ALL" then
								if HardFinger.HardFinger_Config.WhoPulled == true then
									HardFinger.SendChat(text, P.WhoPulledChannel)
								end
							else
								HardFinger.SendChat(text, P.ReportChannel)
							end
							
							WhoPulledTable[specialUniqueKey or destGUID] = {WhoPulled = wpname, SpellPulled = spellID, TimePulled = GetTime()}
						end
					end
				end
			end
		end
	end
end

-- Funo sName (short name, strip away realm name)
function HardFinger.SName(name)
	if name == nil or name:find("-") == nil then
		return name
	else
		return name:match("(.-)-")
	end
end


function HardFinger.BuffDebuffAfterEvent(spellIDToTrack, messageToTrack, roles, func, auraName, spellIDIcon, textDesc, shouldShow, shouldTrack, message, spellID)
    if spellID == spellIDToTrack and message == messageToTrack then
		local _,_,_,_,_,_,_,_,instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
		HardFinger.InstanceSize = instanceSize
		for i = 1, HardFinger.InstanceSize, 1 do
			local iName = UnitName(HardFinger.ValidUnitFrameGUID..i)
			local role = UnitGroupRolesAssigned(iName)
			if string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
				if UnitIsDeadOrGhost(iName or "") == false then
					if func(iName, auraName) == nil then
						if shouldShow == true or shouldShow == 2 or shouldShow == 3 then
							HardFinger.SendChat(iName.." failed miserably and got hit by "..GetSpellLink(spellID)..".", P.ReportChannel)
						end
						if shouldTrack == true or shouldTrack == 1 or shouldTrack == 3 then
							HardFinger.ModifyFailTable(spellIDIcon, textDesc, iName)
						end
					end
				end
			end
        end
    end
end

function HardFinger.HealAbsorbed(message, hasBuff, sourceName, destName, healabsorb)

	healabsorb = healabsorb or 0

	if message == "SPELL_HEAL" then

		if UnitDebuff(destName, hasBuff) ~= nil then

			if UnitGroupRolesAssigned(sourceName) == "HEALER" then

				--HardFinger.DPrint(sourceName, "Healed", destName, "for", healabsorb, param13, param14, param15)
				HardFinger.ModifyFailTable(206610, "Healing Absorbed: ", HardFinger.SName(sourceName), healabsorb)

			end
		end
	end

end


-- Modificar fail Table, descricao = texto no chat

function HardFinger.ModifyFailTable(spellIconOrText, description, creatureName, amountToChange, highestAmount)
	local amountToChange = amountToChange or highestAmount or 1
	local spelln = spellIconOrText
	if type(spelln) == "number" then
		spelln = GetSpellInfo(spellIconOrText)
	end
	local uniqueTableKey = spelln..description

	--HardFinger.DPrint("received: "..uniqueTableKey, spellIcon, description, creatureName, amountToChange)
	FailTable.Data[uniqueTableKey] = FailTable.Data[uniqueTableKey] or {}
	FailTable.Data[uniqueTableKey].description = description
	FailTable.Data[uniqueTableKey].spellIcon = spellIconOrText
	FailTable.Data[uniqueTableKey].players = FailTable.Data[uniqueTableKey].players or {}
	FailTable.Data[uniqueTableKey].players[creatureName] = FailTable.Data[uniqueTableKey].players[creatureName] or {}
	FailTable.Data[uniqueTableKey].players[creatureName].name = creatureName
	FailTable.Data[uniqueTableKey].players[creatureName].counter = FailTable.Data[uniqueTableKey].players[creatureName].counter or 0
	FailTable.Data[uniqueTableKey].players[creatureName].counter = FailTable.Data[uniqueTableKey].players[creatureName].counter + amountToChange
	
	if highestAmount ~= nil then
		if highestAmount > FailTable.Data[uniqueTableKey].players[creatureName].counter then
			FailTable.Data[uniqueTableKey].players[creatureName].counter = highestAmount
		end
	end
	amountToChange = nil

end



-- Funao Send Chat
function HardFinger.SendChat(string, channel)
    if channel == false then
		print(string)
	elseif channel == "GUILD_CHANNEL" then
		SendChatMessage(string, "GUILD")
	elseif (tonumber(P.ReportChannel) or 0) ~= 1 then
		SendChatMessage(string, "CHANNEL", nil, P.ReportChannel)
	else
		SendChatMessage(string, HardFinger.ProperChannel)
	end
end

-- Somar valores para vetor
function HardFinger.SumVectorValues(vector)

	local sum = 0

	local totalEntries = 0

	for _, v in pairs(vector) do
		sum = sum + v.counter

		totalEntries = totalEntries + 1

	end
	return sum, totalEntries

end

-- Formatar damage properly
function HardFinger.FormatDamage(damage)
    local ret = damage
    if damage > 1e6 then
        ret = format("%.1f M", damage / 1e6) -- million
    elseif damage > 1e3 then
        ret = format("%.1f K", damage / 1e3) -- thousand
    end
    return ret
end

HardFinger.SterilizeTable = {}
SterilizeTable = HardFinger.SterilizeTable
function HardFinger.SterilizeUptime(message, destName, spellID)
	if HardFinger.LastEncounter == 1867 and HardFinger.ActiveEncounter == 0 then
		forceEnd = true
	end

	if message == "SPELL_AURA_APPLIED" then -- or message == "SPELL_AURA_REFRESH" then
		if spellID == 208499 or spellID == 211615 then
			SterilizeTable[destName] = SterilizeTable[destName] or {}
			SterilizeTable[destName].count = SterilizeTable[destName].count or 0
			SterilizeTable[destName].buffUptime = SterilizeTable[destName].buffUptime or 0
			SterilizeTable[destName].lastApplied = GetTime()
		end
	end

	if SterilizeTable ~= nil and SterilizeTable ~= {} then
		if forceEnd == true then
			for player, innerTable in pairs(SterilizeTable) do
				HardFinger.DPrint("[Sterilize] Final balance for player..", player)
			    balance = GetTime() - innerTable.lastApplied
			    innerTable.buffUptime = innerTable.buffUptime + balance
			end
			forceEnd = false
			HardFinger.ComputeSterilize()
			return
		end
		
		if spellID == 212103 and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SPELL_ABSORB") then
			SterilizeTable[destName].count = SterilizeTable[destName].count + 1
		end
		if message == "SPELL_AURA_REMOVED" and spellID == 208499 then
			balance = GetTime() - SterilizeTable[destName].lastApplied
			SterilizeTable[destName].buffUptime = SterilizeTable[destName].buffUptime + balance
		end

	end
end


function HardFinger.MakeZerosFailTable(spellID, text, roles)
	if FailTable.Data[spellID..text] == nil then
		local _,_,_,_,_,_,_,_, instanceSize = GetInstanceInfo() -- Needed to handle if people leave the group
		HardFinger.InstanceSize = instanceSize
		for i=1, instanceSize do
			local tempUnitName = UnitName(HardFinger.ValidUnitFrameGUID..i)
			if string.find(string.upper(roles),UnitGroupRolesAssigned(tempUnitName)) or roles == "ALL" then
					HardFinger.ModifyFailTable(spellID, text, tempUnitName, 0)
			end
		end
	end
end

function HardFinger.DPrint(...)
	if UnitName("player") == "Eumesminha" or UnitName("player") == "Camoleze" then
		print(...)
	end
end

function HardFinger.ComputeSterilize()
	for player, innerTable in pairs(HardFinger.SterilizeTable) do
		HardFinger.DPrint("\nComputing for player..", player)
		result = innerTable.count * 2.5 / innerTable.buffUptime * 100
		result = format("%.1f", result)
		HardFinger.ModifyFailTable(208499, "Score! (higher is better): ", HardFinger.SName(player), nil, tonumber(result))
	end
	wipe(SterilizeTable)
end



-- Funo raid target flags ICONs
function HardFinger.GetRaidMarkByFlags(flags)
    if flags == 0 or flags == nil then
        return "" 
    end
    local r = log(flags)/log(2) + 1
    markName = "NONE"
    if r == 1 then
        markName = "STAR"
    elseif r == 6 then
        markName = "SQUARE"
    elseif r == 7 then
        markName = "CROSS"
    elseif r == 8 then
        markName = "SKULL"
    end
    return " {rt"..r.."} ",  MarkName
end

-- Funo HP Porcentagem
function HardFinger.Hpp(unit)
	return math.max(0, UnitHealth(unit)) / math.max(1, UnitHealthMax(unit)) * 100;
end